<form [formGroup]="stockPickerForm">
  <mat-form-field>
    <input matInput placeholder="Symbol e.g AAPL" formControlName="symbol" />

    <mat-error>
      <!--
        REMARKS: this is needed so angular knows to refresh the form status when using a keyboard TAB and async validation.
        I am pretty sure angular 8+ does not need the next *ngIf.
      -->
      <ng-container
        *ngIf="
          (stockPickerForm.controls.symbol.statusChanges | async) !== 'PENDING'
        "
      >
        <div *ngIf="stockPickerForm.controls?.symbol?.errors?.required">
          Please enter a symbol
        </div>
        <div *ngIf="stockPickerForm.controls?.symbol?.errors?.invalidSymbol">
          Invalid symbol
        </div>
      </ng-container>
    </mat-error>
  </mat-form-field>

  <mat-form-field>
    <mat-label>Favorite time period</mat-label>
    <mat-select formControlName="period">
      <mat-option
        *ngFor="let timePeriod of timePeriods"
        [value]="timePeriod.value"
      >
        {{ timePeriod.viewValue }}
      </mat-option>
    </mat-select>
  </mat-form-field>

  <mat-error> {{ error$ | async }} </mat-error>

  <!--
    REMARKS: using !valid instead of invalid as we need to wait for pending status for async validation

    REMARKS: task2 - I am leaving the button here as it does not say anything on the requirements,
     in a real app it might not be desired, on mobile we might use something like angular-pull-to-refresh or ion-refresher (ionic)
  -->
  <button
    [disabled]="!stockPickerForm.valid"
    (click)="fetchQuote()"
    mat-raised-button
  >
    Go
  </button>
</form>

<!-- REMARKS: Example usage for loading indicator -->
<ng-container *ngIf="!(loading$ | async); else: loadingContainer">
  <!--
    REMARKS: finished implementing selectedSymbol
    used in this h2 as an example added a ng container
  -->
  <h2 *ngIf="(selectedSymbol$ | async) as selectedSymbol">
    Chart for {{ selectedSymbol }}
  </h2>
  <ng-container *ngIf="(quotes$ | async) as quotes">
    <!-- REMARKS: task3 - added a filter dates form for the active form -->
    <form [formGroup]="dateRangeForm">
      <mat-expansion-panel>
        <mat-expansion-panel-header>
          <mat-panel-title> Filter </mat-panel-title>
          <mat-panel-description> Date range filtering </mat-panel-description>
        </mat-expansion-panel-header>

        <mat-form-field>
          <mat-label>Choose a start date</mat-label>

          <input
            formControlName="startDate"
            matInput
            #startDateInput
            (focus)="startDatePicker.open()"
            (click)="startDatePicker.open()"
            [matDatepicker]="startDatePicker"
            [min]="minDate$ | async"
            [max]="
              dateRangeForm?.controls?.endDate?.value || (maxDate$ | async)
            "
          />

          <mat-datepicker-toggle
            matSuffix
            [for]="startDatePicker"
          ></mat-datepicker-toggle>

          <mat-datepicker #startDatePicker></mat-datepicker>

          <mat-error>
            <div
              *ngIf="
                dateRangeForm?.controls?.startDate?.errors?.matDatepickerMax
              "
            >
              Start date needs to be before or same as the end date
            </div>

            <div
              *ngIf="
                dateRangeForm?.controls?.startDate?.errors?.matDatepickerMin
              "
            >
              Start date needs to be within range selected above
            </div>
          </mat-error>
        </mat-form-field>

        <mat-form-field *ngIf="startDateInput?.value">
          <mat-label>Choose an end date</mat-label>

          <input
            formControlName="endDate"
            #endDateInput
            matInput
            (focus)="endDatePicker.open()"
            (click)="endDatePicker.open()"
            [matDatepicker]="endDatePicker"
            [min]="dateRangeForm?.controls?.startDate?.value"
            [max]="maxDate$ | async"
          />

          <mat-datepicker-toggle
            matSuffix
            #endDatePicker
            [for]="endDatePicker"
          ></mat-datepicker-toggle>

          <mat-datepicker #endDatePicker></mat-datepicker>
          <mat-error>
            <div
              *ngIf="dateRangeForm?.controls?.endDate?.errors?.matDatepickerMin"
            >
              End date needs to be after or same as the start date
            </div>
            <div
              *ngIf="dateRangeForm?.controls?.endDate?.errors?.matDatepickerMax"
            >
              End date needs to be within range selected above
              {{
                dateRangeForm?.controls?.endDate?.errors?.matDatepickerMax
                  | json
              }}
            </div>
          </mat-error>
        </mat-form-field>
      </mat-expansion-panel>
    </form>
    <mat-divider> </mat-divider>

    <mat-card>
      <ng-container *ngIf="!quotes.length; then: noData"></ng-container>

      <coding-challenge-chart
        *ngIf="!(error$ | async)"
        [data]="quotes"
        [options]="options"
      ></coding-challenge-chart>
    </mat-card>
  </ng-container>
</ng-container>

<!-- REMARKS: Example usage for loading indicator template -->
<ng-template #loadingContainer>
  <mat-card> Loading Data </mat-card>
</ng-template>

<!-- REMARKS: Empty data template -->
<ng-template #noData> <mat-error>No data</mat-error> </ng-template>
